ce.matrix <-
function( cedata, treatment.std, wtp ) {
	if (!is.data.frame(cedata)) {
		stop("WARNING : cedata should be a data.frame")
	}
	
	Mean.Cost <- cedata[,2]
	Mean.Effectiveness <- cedata[,3]
	Treatments <- cedata[,1]
	
	# Data for standart treatment
	pos_std <- which( Treatments == treatment.std )
	cost_std <- Mean.Cost[ pos_std ]
	effect_std <- Mean.Effectiveness[ pos_std ]
	
	# Compute ICER
	ICER <- array(0, length(Treatments) )
	
	ans <- matrix("", 3, 3)
	colnames(ans) <- c("Cost savings", "No difference cost", "Cost greater")
	rownames(ans) <- c("Effectiveness less", "No difference effectiveness", "Effectiveness greater")
	
	for ( i in Treatments ) {
		pos_alt <- which( Treatments == i )
		cost_alt <- Mean.Cost[ pos_alt ] - Mean.Cost[ pos_std ]
		effect_alt <- Mean.Effectiveness[ pos_alt ] - Mean.Effectiveness[ pos_std ]
		ICER[pos_alt] <- ( Mean.Cost[ pos_alt ] - Mean.Cost[ pos_std ] ) / ( Mean.Effectiveness[ pos_alt ] - Mean.Effectiveness[ pos_std ] )
		
		# Casela A
		if ( ( Mean.Cost[ pos_alt ] < Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] < Mean.Effectiveness[ pos_std ] ) ) {
			if ( nchar(ans[1,1]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
			ans[1,1] <- paste(ans[1,1], delimitador, i, sep = "")
		} else {
			# Casela B
			if ( ( Mean.Cost[ pos_alt ] == Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] < Mean.Effectiveness[ pos_std ] ) ) {
			if ( nchar(ans[1,2]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
				ans[1,2] <- paste(ans[1,2], delimitador, i, sep = "")
			} else {
				# Casela C
				if ( ( Mean.Cost[ pos_alt ] > Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] < Mean.Effectiveness[ pos_std ] ) ) {
			if ( nchar(ans[1,3]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
					ans[1,3] <- paste(ans[1,3], delimitador, i, sep = "")
				} else {
					# Casela D
					if ( ( Mean.Cost[ pos_alt ] < Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] == Mean.Effectiveness[ pos_std ] ) ) {
						if ( nchar(ans[2,1]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
						ans[2,1] <- paste(ans[2,1], delimitador, i, sep = "")
					} else {
						# Casela E
						if ( ( Mean.Cost[ pos_alt ] == Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] == Mean.Effectiveness[ pos_std ] ) ) {
							if ( nchar(ans[2,2]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
							ans[2,2] <- paste(ans[2,2], delimitador, i, sep = "")
						} else {
							# Casela F
							if ( ( Mean.Cost[ pos_alt ] > Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] == Mean.Effectiveness[ pos_std ] ) ) {
								if ( nchar(ans[2,3]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
								ans[2,3] <- paste(ans[2,3], delimitador, i, sep = "")
							} else {
								# Casela G
								if ( ( Mean.Cost[ pos_alt ] < Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] > Mean.Effectiveness[ pos_std ] ) ) {
									if ( nchar(ans[3,1]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
									ans[3,1] <- paste(ans[3,1], delimitador, i, sep = "")
								} else {
									# Casela H
									if ( ( Mean.Cost[ pos_alt ] == Mean.Cost[ pos_std ] ) && ( Mean.Effectiveness[ pos_alt ] > Mean.Effectiveness[ pos_std ] ) ) {
										if ( nchar(ans[3,2]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
										ans[3,2] <- paste(ans[3,2], delimitador, i, sep = "")
									} else {
									# Casela I
										if ( nchar(ans[3,3]) > 0 ) { delimitador <- ", " } else { delimitador <- "" }
										ans[3,3] <- paste(ans[3,3], delimitador, i, sep = "")
									}
								}
							}
						}
					}
				}
			}		
		}
	}
	# print( Treatments )
	# names(ICER) <- Treatments
	# print( ICER )
	# cat("-----\n\n")
	return(ans)
	
}
