ce.matrix.show.data.table <-
function(x, col.names = TRUE, row.names = FALSE, title = "ArvoRe") {
	Original.Dada <- x
	dimlin <- dim(x)[1]
	dimcol <- dim(x)[2]
	nomescolunas <- colnames(x)
	nomeslinhas <- rownames(x)
	
	require(tcltk)
	tclRequire("Tktable")

	myRarray <- array(,0)
	
	if ( col.names ) {
		myRarray <- c(myRarray, nomescolunas)
	} 
	
	for ( j in 1:dimlin ) {
		for ( i in 1:dimcol ) {
			myRarray <- c(myRarray, as.character( x[j,i] ) )
		}
	}
	
	myRarray <- aplicaaspas(myRarray)
	# print("Mostrando myRarray aplicaaspas : \n")
	# print(myRarray)
	
	if ( col.names ) {
		dimlin <- dimlin + 1
	}
	
	#dim(myRarray) <- c( dimlin, dimcol )
	myRarray <- matrix( myRarray, dimlin, dimcol, byrow = TRUE)
	
	nomeslinhas <- aplicaaspas( c(" ", nomeslinhas) )
	myRarray <- as.matrix( cbind(nomeslinhas, myRarray) )
	dimcol <- dimcol + 1
	
	
	# print("Mostrando myRarray : \n")
	# print(myRarray)
	
	for (j in (0: (dimlin - 1) )) {
	for (i in ( 0: (dimcol - 1) )) {
			.Tcl(paste("set tclarray(",j,",",i,") ",myRarray[j+1,i+1], sep=""))
		}
	}

	ttshow.data.table <-tktoplevel()
	title <- "ArovRe - Cost-Effectiveness Matrix"
	tkwm.title(ttshow.data.table,title)
	table1 <- tkwidget(ttshow.data.table,
						"table",
						variable="tclarray",
						rows=dimlin,
						cols=dimcol,
						titlerows="1",
						titlecols="1",
						selectmode="extended",
						colwidth="25",
						background="white",
						xscrollcommand=function(...) tkset(xscr,...),
						yscrollcommand=function(...) tkset(yscr,...)
					)
					
	xscr <-tkscrollbar(ttshow.data.table, orient="horizontal", command=function(...)tkxview(table1,...))
	yscr <- tkscrollbar(ttshow.data.table, command=function(...)tkyview(table1,...))
					
	tkpack(table1)
	# tkpack(yscr)
	# tkpack(xscr)
	
	OnExport <- function(Original.Dada) {
		filetypeWindow <- tktoplevel()
		title <- "ArvoRe - Export"
		tkwm.title(filetypeWindow,title)
		
	    frameOverall <- tkframe(filetypeWindow)
	    frameUpper <- tkframe(frameOverall, relief="groove", borderwidth=2)
	    frameLower <- tkframe(frameOverall, borderwidth=2)
	
		tkgrid(tklabel(frameUpper,text="Select a file format:"))
		filetypes <- c("CSV (Comma-separated values)","TXT (Tab text plain)","All files")
		fileextensions <- c(".csv", ".txt", " ")
			
		widthcombo <- max( nchar(filetypes) )
			
		comboBox <- tkwidget(frameUpper,"ComboBox", width = widthcombo, editable = FALSE, values = filetypes)
		tkgrid(comboBox)
		
		OnOK <- function() {
	   		filetypeChoice <- filetypes[as.numeric(tclvalue(tcl(comboBox,"getvalue")))+1]
	   		fileextChoice <- fileextensions[as.numeric(tclvalue(tcl(comboBox,"getvalue")))+1]
	   		tkdestroy(filetypeWindow)
	   		filetypes <- paste("{{ ", filetypeChoice, "}", " {", fileextChoice, "}}", sep = "")
	   		fileName <- tclvalue(tkgetSaveFile(filetypes=filetypes))
	   		
			if (!nchar(fileName))
				tkfocus(filetypeWindow)
			else {
				
				ans <- substr(fileName,nchar(fileName)-3,nchar(fileName))
				if ( fileextChoice == ".csv" ) {
					if (ans == ".csv") {
						write.csv2(Original.Dada, file = fileName, row.names = TRUE)
					} else {
						fileName <- paste(fileName, ".csv", sep = "")
						write.csv2(Original.Dada, file = fileName, row.names = TRUE)
					}
				}
				if ( fileextChoice == ".txt" ) {
					if (ans == ".txt") {
						write.table(Original.Dada, file = fileName, sep = "\t")
					} else {
						fileName <- paste(fileName, ".txt", sep = "")
						write.table(Original.Dada, file = fileName, sep = "\t")
					}
				}
				if ( fileextChoice == " " ) {
					if (ans == ".txt") {
						write.table(Original.Dada, file = fileName, sep = "\t")
					} else {
						fileName <- paste(fileName, ".txt", sep = "")
						write.table(Original.Dada, file = fileName, sep = "\t")
					}
				}	
				tkfocus(ttshow.data.table)
			}	
		    	}
	   	
	   	OnCancel <- function() {
	    	tkdestroy(filetypeWindow)
	    	tkfocus(ttshow.data.table)
	   	}
	   	
	   	.Width.but <- 10
		.Height.but <- 1
		
		OK.but <-tkbutton(frameLower,text="OK", width=.Width.but, height=.Height.but, command=OnOK)
		Cancel.but <-tkbutton(frameLower,text="Cancel", width=.Width.but, height=.Height.but, command=OnCancel)
		
		tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)
		
		tkgrid(frameUpper,sticky="nwe")
		tkgrid(frameLower,sticky="nwe")
		tkgrid(frameOverall)
		tkbind(filetypeWindow, "<Return>",OnOK)
		tkbind(filetypeWindow, "<Escape>",OnOK)
			
		tkfocus(filetypeWindow)
	}	
	
	OnOK <- function() {
		tkdestroy(ttshow.data.table)
		# if (returntt) {
			# tkwm.deiconify(tt)
			# tkfocus(tt)
		# }
    }
		
  	.Width.but <- 10
	.Height.but <- 1
		
	OK.but <-tkbutton(ttshow.data.table,text="OK", width=.Width.but, height=.Height.but, command=OnOK)
	Export.but <-tkbutton(ttshow.data.table,text="Export", width=.Width.but, height=.Height.but, command=function() {OnExport(Original.Dada)})
		
	tkpack(OK.but, Export.but)
	tkbind(ttshow.data.table, "<Return>",OnOK)
	tkbind(ttshow.data.table, "<Escape>",OnOK)
	
	tkfocus(ttshow.data.table)
	
	

}
