dialog.distribution.window <-
function(...) {
	if (!exists("distributionMAT",.EnvironmentArvoRe)) {
		new.distribution.list() # se no existe uma tabela de variaveis, ento ele cria.
		#assign("distributionMAT", ans, envir = .EnvironmentArvoRe)
	}
	
	distributionWindow <- tktoplevel()
	title <- "ArvoRe - Distributions"
	tkwm.title(distributionWindow,title)
	
	frameOverall <- tkframe(distributionWindow)
	frameUpper <- tkframe(frameOverall, relief="groove", borderwidth=0)
	frameUpperLeft <- tkframe(frameUpper, relief="groove", borderwidth=2)
	frameUpperRigth <- tkframe(frameUpper, relief="groove", borderwidth=2)
	frameLower <- tkframe(frameOverall, relief="groove", borderwidth=2)
	
	scrvar <- tkscrollbar(frameUpperRigth, repeatinterval=5,
					command=function(...)tkyview(tlvar,...))
	tlvar <- tklistbox(frameUpperRigth,height=4,selectmode="single",
					yscrollcommand=function(...)tkset(scrvar,...),background="white")
	tkgrid(tklabel(frameUpperRigth,text="Distributions"))
	tkgrid(tlvar,scrvar)
	tkgrid.configure(scrvar,rowspan=4,sticky="nsw")
	
	tkgrid(frameUpperLeft, frameUpperRigth,sticky="nsw")
	tkgrid(frameUpper,sticky="ns")
	tkgrid(frameLower,sticky="ns")
	
	distributionsnames <- distributionMAT[,1]
	
	if (length(distributionsnames) > 0) {
		for (i in (1:length(distributionsnames))) {
	    	tkinsert(tlvar,"end",distributionsnames[i])
		}
	}
	
	AddSelection <- function()
	{
	    adddistributionWindow <- tktoplevel()
	    title <- "ArvoRe - Distributions"
	    tkwm.title(adddistributionWindow,title)
	    
	    frameOverall <- tkframe(adddistributionWindow)
	    frameUpper <- tkframe(frameOverall, relief="groove", borderwidth=2)
	    frameLeft <- tkframe(frameUpper, relief="groove", borderwidth=2)
	    frameRight <- tkframe(frameUpper, relief="groove", borderwidth=2)
	    frameLower <- tkframe(frameOverall, borderwidth=2)
	    
	    tkgrid(tklabel(frameOverall,text="New Distribution"))
	    
		# The frame for distribution buttons

		# graphical elements for parameter and related labels
		selecteddistributionflg <- tclVar("FALSE")
		
		Namevar <- tclVar("")
		campowidth <- 25
		Name.var.Value  <- tkentry(frameRight, width=campowidth,textvariable=Namevar, state="disabled")
		Label.NameVarValue <- tklabel(frameRight,text="Randon Variable Name")
		
		hideEntryName <- function() {
			tkconfigure(Name.var.Value, state="disabled")
			tkgrid("forget", Label.NameVarValue)
			tkgrid("forget", Name.var.Value)	
			tcl("set", selecteddistributionflg, "FALSE")
		}
		showEntryName <- function(selectdistrflg) {
			tkgrid(Label.NameVarValue, sticky = "n")
			tkgrid(Name.var.Value, sticky = "n")		
			tcl("set", Namevar, "")
			tkconfigure(Name.var.Value, state="normal")
			tcl("set", selecteddistributionflg, selectdistrflg)
		}

		Parameter1var <- tclVar("")
		campowidth <- 25
		Parameter1.var.Value  <- tkentry(frameRight, width=campowidth,textvariable=Parameter1var, state="disabled")
		Label.Parameter1.var.Value <- tklabel(frameRight,text="Parameter 1")
		
		hideParameter1 <- function() {
			tkconfigure(Parameter1.var.Value, state="disabled")
			tkgrid("forget", Label.Parameter1.var.Value)
			tkgrid("forget", Parameter1.var.Value)	
			tcl("set", selecteddistributionflg, "FALSE")
		}
		showParameter1 <- function(selectdistrflg, labelvalue) {
			tkconfigure(Label.Parameter1.var.Value, text=labelvalue)
			tkconfigure(Parameter1.var.Value, state="normal")
			tkgrid(Label.Parameter1.var.Value, sticky = "n")
			tkgrid(Parameter1.var.Value, sticky = "n")		
			tcl("set", Parameter1var, "")
			tcl("set", selecteddistributionflg, selectdistrflg)
		}
		
		Parameter2var <- tclVar("")
		campowidth <- 25
		Parameter2.var.Value  <- tkentry(frameRight, width=campowidth,textvariable=Parameter2var, state="disabled")
		Label.Parameter2.var.Value <- tklabel(frameRight,text="Parameter 2")
		
		hideParameter2 <- function() {
			tkconfigure(Parameter2.var.Value, state="disabled")
			tkgrid("forget", Label.Parameter2.var.Value)
			tkgrid("forget", Parameter2.var.Value)	
			tcl("set", selecteddistributionflg, "FALSE")
		}
		showParameter2 <- function(selectdistrflg, labelvalue) {
			tkconfigure(Label.Parameter2.var.Value, text=labelvalue)
			tkconfigure(Parameter2.var.Value, state="normal")
			tkgrid(Label.Parameter2.var.Value, sticky = "n")
			tkgrid(Parameter2.var.Value, sticky = "n")		
			tcl("set", Parameter2var, "")
			tcl("set", selecteddistributionflg, selectdistrflg)
		}
		
		Parameter3var <- tclVar("")
		campowidth <- 25
		Parameter3.var.Value  <- tkentry(frameRight, width=campowidth,textvariable=Parameter3var, state="disabled")
		Label.Parameter3.var.Value <- tklabel(frameRight,text="Parameter 2")
		
		hideParameter3 <- function() {
			tkconfigure(Parameter3.var.Value, state="disabled")
			tkgrid("forget", Label.Parameter3.var.Value)
			tkgrid("forget", Parameter3.var.Value)	
			tcl("set", selecteddistributionflg, "FALSE")
		}
		showParameter3 <- function(selectdistrflg, labelvalue) {
			tkconfigure(Label.Parameter3.var.Value, text=labelvalue)
			tkconfigure(Parameter3.var.Value, state="normal")
			tkgrid(Label.Parameter3.var.Value, sticky = "n")
			tkgrid(Parameter3.var.Value, sticky = "n")		
			tcl("set", Parameter3var, "")
			tcl("set", selecteddistributionflg, selectdistrflg)
		}
		
		Notesvar <- tclVar("")
		campowidth <- 25
		Notes.var.Value  <- tkentry(frameRight, width=campowidth,textvariable=Notesvar, state="disabled")
		Label.Notes.var.Value <- tklabel(frameRight,text="Notes")
		
		hideNotes <- function() {
			tkconfigure(Notes.var.Value, state="disabled")
			tkgrid("forget", Label.Notes.var.Value)
			tkgrid("forget", Notes.var.Value)	
			tcl("set", selecteddistributionflg, "FALSE")
		}
		showNotes <- function(selectdistrflg, labelvalue) {
			tkconfigure(Label.Notes.var.Value, text=labelvalue)
			tkconfigure(Notes.var.Value, state="normal")
			tkgrid(Label.Notes.var.Value, sticky = "n")
			tkgrid(Notes.var.Value, sticky = "n")		
			tcl("set", Notesvar, "")
			tcl("set", selecteddistributionflg, selectdistrflg)
		}
		
		# Botoes para a distribuio personalizada
		OnCustomImportCSV <- function() {
			fileName <- tclvalue(tkgetOpenFile(filetypes="{{CSV Files} {.csv}} {{All files} *}"))
			if (nchar(fileName) <= 0) {
				#tkfocus(tt)
			} else {
				ans <- read.csv(fileName)
				if ( dim(ans)[2] < 2 ) {
					# Tenta a leitura no formato CSV semicolon
					ans <- read.csv2(fileName)[,1:3]
				}
				names(ans) <- c("Random.Variable", "px", "Px")
				assign(".Distr.Custom.Edt", ans, .EnvironmentArvoRe)
				tkconfigure(Custom.view.but, state="normal")
			}
		}

		OnCustomImportObj <- function() {
			if ( dim(ans)[1] > 0 && dim(ans)[1] >= 3 ) {
				names(ans) <- c("Random.Variable", "px", "Px")
				ans <- ans[,1:3]

				ALLOk <- TRUE
				
				ans[,1] <- as.numeric(ans[,1])
				ans[,2] <- as.numeric(ans[,2])
				ans[,3] <- as.numeric(ans[,3])
			
				navalues <- is.na( ans[,2] )
				if ( sum(navalues) == 0 ) {
					if ( sum(ans[,2]) != 1 ) {
						ans[,2] <- ans[,2] / sum(ans[,2])
						print("WARNING : px weighted to be a density probability function! \n")
					}
					ans[,3] <- cumsum(ans[,2])
				} else {
					ALLOk <- FALSE
				}
				
				navalues <- is.na( ans[,3] )
				if ( sum(navalues) == 0 ) {
					if ( max(ans[,3]) != 1.0 ) { ALLOk <- FALSE }
					if ( min(ans[,3]) >= 0.0 ) { ALLOk <- FALSE }
				} else {
					ALLOk <- FALSE
				}
				
				if ( ALLOk ) {
					assign(".Distr.Custom.Edt", ans, .EnvironmentArvoRe)
				}
			}
		}
		
		OnCustomImportEdit <- function() {
			ans <- data.frame("Random.Variable" = as.numeric(array(,0)) , "Probability" = as.numeric(array(,0)), "Cumulative" = as.numeric(array(,0)) )
			ans <- fix(ans)
			
			print(ans)

			if ( dim(ans)[1] > 0 && dim(ans)[2] >= 3 ) {
				names(ans) <- c("Random.Variable", "px", "Px")
				ans <- ans[,1:3]

				ALLOk <- TRUE
				
				ans[,1] <- as.numeric(ans[,1])
				ans[,2] <- as.numeric(ans[,2])
				ans[,3] <- as.numeric(ans[,3])

				navalues <- is.na( ans[,2] )
				if ( sum(navalues) == 0 ) {
					if ( sum(ans[,2]) != 1 ) {
						ans[,2] <- ans[,2] / sum(ans[,2])
						print("WARNING : px weighted to be a density probability function! \n")
					}
					ans[,3] <- cumsum(ans[,2])
				} else {
					ALLOk <- FALSE
					tkconfigure(Custom.view.but, state="disabled")	
					print("WARNING : NA values detected for probability. \n")
				}
				
				navalues <- is.na( ans[,3] )
				if ( sum(navalues) == 0 ) {
					if ( max(ans[,3]) != 1.0 ) { ALLOk <- FALSE ; tkconfigure(Custom.view.but, state="disabled") }
					if ( min(ans[,3]) < 0.0 ) { ALLOk <- FALSE ; tkconfigure(Custom.view.but, state="disabled") }
				} else {
					ALLOk <- FALSE
					tkconfigure(Custom.view.but, state="disabled")
					print("WARNING : NA values detected for CDF. \n")
				}
				
				if ( ALLOk ) {
					assign(".Distr.Custom.Edt", ans, .EnvironmentArvoRe)
					tkconfigure(Custom.view.but, state="normal")
				}
			} else {
				print("WARNING : invalid object. \n")
			}
			
		}
		
		OnCustomViewData <- function() {
			ans <- get(".Distr.Custom.Edt", envir = .EnvironmentArvoRe)
			fix(ans)
		}
		
		.Width.but <- 18
		.Height.but <- 1
		Custom.import.csv.but <-tkbutton(frameRight,text="Import from CSV...", width=.Width.but, height=.Height.but, command=OnCustomImportCSV)
		Custom.edit.but <-tkbutton(frameRight,text="Edit", width=.Width.but, height=.Height.but, command=OnCustomImportEdit)
		Custom.view.but <-tkbutton(frameRight,text="View data", width=.Width.but, height=.Height.but, command=OnCustomViewData)
		Custom.separator.label <- tklabel(frameRight,text="     ")
		
		hideCustom <- function() {
			tkconfigure(Custom.import.csv.but, state="disabled")
			tkconfigure(Custom.edit.but, state="disabled")
			tkconfigure(Custom.view.but, state="disabled")
			tkgrid("forget", Custom.separator.label)
			tkgrid("forget", Custom.import.csv.but)
			tkgrid("forget", Custom.edit.but)	
			tkgrid("forget", Custom.view.but)	
			tcl("set", selecteddistributionflg, "FALSE")
		}
		showCustom <- function(selectdistrflg) {
			tkconfigure(Custom.import.csv.but, state="normal")
			tkconfigure(Custom.edit.but, state="normal")
			tkconfigure(Custom.view.but, state="disabled")
			tkgrid(Custom.separator.label, sticky = "n")
			tkgrid(Custom.import.csv.but, sticky = "n")
			tkgrid(Custom.edit.but, sticky = "n")		
			tkgrid(Custom.view.but, sticky = "n")		
			tcl("set", selecteddistributionflg, selectdistrflg)
		}
		
		# buttons functions
		OnNormalAdd <- function() {
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("norm")
			showParameter1("norm", "Mean")
			showParameter2("norm", "SD")
			showNotes("norm", "Notes")
				
			tkconfigure(Normal.but, state="disabled")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")		
		}
		OnLogNormalAdd <- function() {
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("lnorm")
			showParameter1("lnorm", "Mean Log")
			showParameter2("lnorm", "SD Log")
			showNotes("lnorm", "Notes")
				
			tkconfigure(LogNormal.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")		
		}
		OnBetaAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("beta")
			showParameter1("beta", "shape1")
			showParameter2("beta", "shape2")
			showNotes("beta", "Notes")
				
			tkconfigure(Beta.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		OnChisquareAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("chisq")
			showParameter1("chisq", "df")
			showParameter2("chisq", "ncp")
			showNotes("chisq", "Notes")
			
			tcl("set", Parameter2var, "0")
				
			tkconfigure(Chisquare.but, state="disabled")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		OnGammaAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("gamma")
			showParameter1("gamma", "shape")
			showParameter2("gamma", "rate")
			showNotes("gamma", "Notes")
				
			tkconfigure(Gamma.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		OnExponentialAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("exp")
			showParameter1("exp", "rate")
			showNotes("exp", "Notes")
				
			tkconfigure(Exponential.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		OnPoissonAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("pois")
			showParameter1("pois", "lambda")
			showNotes("pois", "Notes")
				
			tkconfigure(Poisson.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		OnTriangularAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("triangle")
			showParameter1("triangle", "min")
			showParameter2("triangle", "max")
			showParameter3("triangle", "mode")
			showNotes("triangle", "Notes")
				
			tkconfigure(Triangular.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Uniform.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		
		OnUniformAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}
			showEntryName("unif")
			showParameter1("unif", "min")
			showParameter2("unif", "max")
			showNotes("unif", "Notes")
				
			tkconfigure(Uniform.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Custom.but, state="normal")				
		}
		OnCustomAdd <- function() {  
			distrselecvalue <- as.character( tclvalue(selecteddistributionflg) )
			if ( distrselecvalue != "FALSE" ) {
				hideEntryName() ; hideParameter1() ; hideParameter2() ; hideParameter3() ; hideNotes() ; hideCustom()
			}

			showEntryName("chisq")
			showNotes("customdistr", "Notes")
			showCustom("customdistr")
			
			tcl("set", selecteddistributionflg, "customdistr")
			
			tkconfigure(Custom.but, state="disabled")
			tkconfigure(Normal.but, state="normal")
			tkconfigure(LogNormal.but, state="normal")
			tkconfigure(Beta.but, state="normal")
			tkconfigure(Chisquare.but, state="normal")
			tkconfigure(Exponential.but, state="normal")
			tkconfigure(Poisson.but, state="normal")
			tkconfigure(Gamma.but, state="normal")
			tkconfigure(Triangular.but, state="normal")
			tkconfigure(Uniform.but, state="normal")				
		}
		
		.Width.but <- 13
		.Height.but <- 1
		
		Normal.but <-tkbutton(frameLeft,text="Normal", width=.Width.but, height=.Height.but, command=OnNormalAdd)
		LogNormal.but <-tkbutton(frameLeft,text="LogNormal", width=.Width.but, height=.Height.but, command=OnLogNormalAdd)
		Beta.but <-tkbutton(frameLeft,text="Beta", width=.Width.but, height=.Height.but, command=OnBetaAdd)
		Chisquare.but <-tkbutton(frameLeft,text="Chisquare", width=.Width.but, height=.Height.but, command=OnChisquareAdd)
		Gamma.but <-tkbutton(frameLeft,text="Gamma", width=.Width.but, height=.Height.but, command=OnGammaAdd)
		Exponential.but <-tkbutton(frameLeft,text="Exponential", width=.Width.but, height=.Height.but, command=OnExponentialAdd)
		Poisson.but <-tkbutton(frameLeft,text="Poisson", width=.Width.but, height=.Height.but, command=OnPoissonAdd)
		Uniform.but <-tkbutton(frameLeft,text="Uniform", width=.Width.but, height=.Height.but, command=OnUniformAdd)
		Triangular.but <-tkbutton(frameLeft,text="Triangular", width=.Width.but, height=.Height.but, command=OnTriangularAdd)
		Custom.but <-tkbutton(frameLeft,text="Custom", width=.Width.but, height=.Height.but, command=OnCustomAdd)

		tkgrid(Beta.but, sticky = "n")
		tkgrid(Chisquare.but, sticky = "n")
		tkgrid(Exponential.but, sticky = "n")
		tkgrid(Gamma.but, sticky = "n")
		tkgrid(LogNormal.but, sticky = "n")
		tkgrid(Normal.but, sticky = "n")
		tkgrid(Poisson.but, sticky = "n")
		tkgrid(Uniform.but, sticky = "n")
		tkgrid(Triangular.but, sticky = "n")
		tkgrid(tklabel(frameLeft,text="     "), sticky = "n")
		tkgrid(Custom.but, sticky = "n")
	
		OnOkAdd <- function() {
			Allok <- TRUE
			
			NameVal <- as.character(tclvalue(Namevar))
			NameVal <- str_replace(as.character(tclvalue(Namevar))," ","")
			DistributionVal <- as.character(tclvalue(selecteddistributionflg))
			Parameter1 <- as.numeric(tclvalue(Parameter1var))
			Parameter2 <- as.numeric(tclvalue(Parameter2var))
			Parameter3 <- as.numeric(tclvalue(Parameter3var))
			NotesVal <- as.character(tclvalue(Notesvar))
									
			if((nchar(NameVal) <= 0)&& Allok) {
				Allok <- FALSE
				msg <- "Invalid distribution name."
				tkmessageBox(message = msg, icon="error")
				tkfocus(adddistributionWindow)
			}
			if((DistributionVal == "FALSE")&& Allok) {
				Allok <- FALSE
				msg <- "None distribution defined."
				tkmessageBox(message = msg, icon="error")
				tkfocus(adddistributionWindow)
			}

			# Teste da validade dos parmetros para as distribuies
			if( DistributionVal == "beta" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 2 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}					
				if ( ( ( Parameter1 <= 0 ) || ( Parameter2 <= 0 ) ) && Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'shape1' and 'shape2' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- Parameter1 / ( Parameter1 + Parameter2 )
				ParametersValue <- paste("shape1=",Parameter1,","," shape2=",Parameter2, sep="")
			}
			
			if( DistributionVal == "chisq" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid ncp parameter value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if ( Parameter1 < 0 && Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'df' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- Parameter1 + Parameter2
				ParametersValue <- paste("df=",Parameter1,","," ncp=",Parameter2, sep="")
			}
			
			if( DistributionVal == "exp" && Allok) { # bug na confirmao de param1
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}

				if ( Parameter1 < 0 && Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'rate' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- 1 / Parameter1 
				ParametersValue <- paste("rate=",Parameter1, sep="")
			}

			if( DistributionVal == "gamma" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 2 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}				
				if ( ( ( Parameter1 <= 0 ) || ( Parameter2 <= 0 ) ) && Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'shape' and 'rate' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- Parameter1 / Parameter2 
				ParametersValue <- paste("shape=",Parameter1,","," rate=",Parameter2, sep="")
			}

			if( DistributionVal == "lnorm" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 2 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}				
				if ( ( Parameter2 <= 0 ) && Allok ) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'sd' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- exp(Parameter1 + (1/2) * Parameter2^2) # E(X) = exp( + 1/2 s^2)
				ParametersValue <- paste("meanlog=",Parameter1,","," sdlog=",Parameter2, sep="")
			}
			
			if( DistributionVal == "norm" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 2 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}				
				if ( ( Parameter2 <= 0 ) && Allok ) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'sd' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- Parameter1 
				ParametersValue <- paste("mean=",Parameter1,","," sd=",Parameter2, sep="")
			}

			if( DistributionVal == "pois" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter lambda value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}

				if ( Parameter1 < 0 && Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'lambda' must be greater than zero."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				MeanValue <- Parameter1
				ParametersValue <- paste("lambda=",Parameter1, sep="")
			}
			
			if( DistributionVal == "triangle" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 1 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 2 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}	
				if((!is.numeric(Parameter3))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 3 value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				
				if (!( ( Parameter1 < Parameter3 ) && ( Parameter3 < Parameter2 ) ) && Allok ) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'min' must be less than 'mode', and mode less than 'max'."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}				
				
				MeanValue <- ( Parameter1 + Parameter2 + Parameter3 ) / 3
				ParametersValue <- paste("a=", Parameter1,", b=", Parameter2,", c=", Parameter3, sep="")
			}

			if( DistributionVal == "unif" && Allok) {
				if((!is.numeric(Parameter1))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 'min' value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}
				if((!is.numeric(Parameter2))&& Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter 'max' value."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}				
				if ( ( Parameter2 <= Parameter1 ) && Allok) {
					Allok <- FALSE
					msg <- "Invalid parameter value. 'max' parameter must be greater than 'min'."
					tkmessageBox(message = msg, icon="error")
					tkfocus(adddistributionWindow)
				}

				MeanValue <- 0.5 * ( Parameter2 + Parameter1 )
				ParametersValue <- paste("min=",Parameter1,","," max=",Parameter2, sep="")

			}
			
			if( DistributionVal == "customdistr" && Allok) {
				# realizar um teste de validade dessa distribuio
				
				ans <- get(".Distr.Custom.Edt", envir = .EnvironmentArvoRe)
				# "Random.Variable", "px", "Px"
				MeanValue <- sum(ans$"Random.Variable" * ans$"px")
				
			}
			
			# Este sistema deve mudar para uma soluo que permita esses nomes
			# Algo como a gerao das variaveis com nomes padronizados segundo 
			# o dataframe das variaveis, num momento de processamento, esses
			# nomes de variaveis sao trocados nas strings de expresso pelos
			# nomes padronizados
			protectednames <- ls(, envir = .EnvironmentArvoRe)
			# print(protectednames)
			if((sum(NameVal == protectednames) > 0)&& Allok) {
				Allok <- FALSE
				msg <- "The system is current using this distribution name. Please chose another name."
				tkmessageBox(message = msg, icon="error")
				tkfocus(adddistributionWindow)
			}
			
			if(Allok) {
				# apenas o caso especial da custom distr
				if( DistributionVal == "customdistr" ) {
					assign( paste(".Distr.Custom.", NameVal, sep=""), ans, .EnvironmentArvoRe)
					ParametersValue <- paste(".Distr.Custom.", NameVal, "$x,",
										".Distr.Custom.", NameVal, "$px, cumulative = TRUE", sep="")
				}
				
				# Get all distributions names
				existsVarNames <- distributionMAT$Name

				if( sum(NameVal == existsVarNames) > 0 ) {
					msg <- paste("This distribution name is already used. Setting distribution name to '",oldNameVal,"_'",sep="")
					tkmessageBox(message = msg, icon="warning")
				} else {
					newdistributionline <- data.frame("Name" = NameVal, "Fix.Value" = MeanValue, "Distribution" = DistributionVal, "Parameters" = ParametersValue, "Notes" = NotesVal )
					safedofunction(TheTree, .EnvironmentArvoRe, .modeltypeArvore)
					setdistributionlist(distributionMAT = distributionMAT, newdistributionline = newdistributionline, action = "add")
				
					# print(distributionMAT)
					tkinsert(tlvar,"end",NameVal)
					tkdestroy(adddistributionWindow)
				}
				
				tkfocus(distributionWindow)
			}
			
		}
		
		OnCanceladd <- function() {
			tkdestroy(adddistributionWindow)
			tkfocus(distributionWindow)
		}
		
		.Width.but <- 10
		.Height.but <- 1

		OK.but <-tkbutton(frameLower,text="OK", width=.Width.but, height=.Height.but, command=OnOkAdd)
		Cancel.but <-tkbutton(frameLower,text="Cancel", width=.Width.but, height=.Height.but, command=OnCanceladd)
		
		tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)
		
		tkgrid(frameUpper,sticky="nwe")
		tkgrid(frameLeft, frameRight, sticky="nwe")
		tkgrid(frameLower,sticky="nwe")
		tkgrid(frameOverall)
		
		tkbind(adddistributionWindow, "<Return>",OnOkAdd)
		tkbind(adddistributionWindow, "<Escape>",OnCanceladd)
		
		tkfocus(adddistributionWindow)
	}

	DeleteSelection <- function()
	{
	    distributionIndex <- as.integer(tkcurselection(tlvar))
	    distributionslist <- distributionMAT$Name
	    distributiontodelete <- as.character(distributionslist[distributionIndex+1])
	    safedofunction(TheTree, .EnvironmentArvoRe, .modeltypeArvore)
	#	print(distributiontodelete)
	    setdistributionlist(distributionMAT = distributionMAT, distribution.name = distributiontodelete, action = "delete")
		
		commandoprocessar <- paste("rm(",distributiontodelete, ", envir = .EnvironmentArvoRe)", sep="")
		eval(parse(text=commandoprocessar))
		commandoprocessar <- paste("rm(",distributiontodelete, ", envir = .GlobalEnv)", sep="")
		eval(parse(text=commandoprocessar))
		
	    tkdelete(tlvar,distributionIndex)
	    tkfocus(distributionWindow)
	}
	
	EditSelection <- function()
	{	
	    distributionIndex <- as.integer(tkcurselection(tlvar))

	   	distributionslist <- distributionMAT$Name
	   	distributionselected <- as.character(distributionslist[distributionIndex+1])
	    	
	   	adddistributionWindow <- tktoplevel()
	   	title <- "ArvoRe - Distributions"
	   	tkwm.title(adddistributionWindow,title)
	    	
	   	frameOverall <- tkframe(adddistributionWindow)
	   	frameUpper <- tkframe(frameOverall, relief="groove", borderwidth=2)
	   	frameLower <- tkframe(frameOverall, borderwidth=2)
	    	
	   	tkgrid(tklabel(frameOverall,text="Variable Properties"))
	    
	   	distributionMATnames <- names(distributionMAT)
	   	Data <- subset(distributionMAT, Name == distributionselected, select = distributionMATnames)

		OnCanceladd <- function() {
			tkdestroy(adddistributionWindow)
			tkfocus(distributionWindow)
		}
		
		.Width.but <- 10
		.Height.but <- 1

		OK.but <-tkbutton(frameLower,text="OK", width=.Width.but, height=.Height.but, command=OnOkAdd)
		Cancel.but <-tkbutton(frameLower,text="Cancel", width=.Width.but, height=.Height.but, command=OnCanceladd)
		
		tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)
		
		tkgrid(frameUpper,sticky="nwe")
		tkgrid(frameLower,sticky="nwe")
		tkgrid(frameOverall)
		
		tkbind(adddistributionWindow, "<Return>",OnOkAdd)
		tkbind(adddistributionWindow, "<Escape>",OnCanceladd)
		
		tkfocus(adddistributionWindow)
		
	}

	OnOK <- function()
	{
		tkdestroy(distributionWindow)
		tkfocus(tt)
	}
		
	.Width.but <- 10
	.Height.but <- 1
	
	OK.but <-tkbutton(frameOverall,text="OK", width=.Width.but, height=.Height.but, command=OnOK)
	Edit.but <-tkbutton(frameUpperLeft,text="Edit", state = "disabled", width=.Width.but, height=.Height.but,command=EditSelection)
	# Edit.but <-tkbutton(frameUpperLeft,text="Edit", width=.Width.but, height=.Height.but,command=EditSelection)
	Add.but <-tkbutton(frameUpperLeft,text="New", width=.Width.but, height=.Height.but,command=AddSelection)
	Delete.but <-tkbutton(frameUpperLeft,text="Delete", width=.Width.but, height=.Height.but,command=DeleteSelection)

	tkbind(distributionWindow, "<Return>",OnOK)
	tkbind(distributionWindow, "<Escape>",OnOK)
		
	tkgrid(OK.but, sticky = "s", padx = 5, pady = 5)
	tkgrid(Add.but, sticky = "s", padx = 5, pady = 5)
	tkgrid(Delete.but, sticky = "s", padx = 5, pady = 5)
	tkgrid(Edit.but, sticky = "s", padx = 5, pady = 5)
	
	tkgrid(frameOverall)
	
	posiciona.janela.no.mouse(distributionWindow, 250, 160)
					
	tkfocus(distributionWindow)
}
