dialog.sensitivityanalysis.w2.window <-
function(...) {
	nodeSec <- nodoselecionado()
	if ( nodeSec[1] == " ") {
		msg <- paste("None node selected. Select a tree node and try again.")
		tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
		.begin.sim <- FALSE
		tkfocus(tt)
	} else {
		node.number <- as.numeric(nodeSec[3])
		column <- as.numeric(nodeSec[2])
		position <- intersect(which((TheTree$Level == column)),which(TheTree$Node.N == node.number))
		node.type <- TheTree$Type[position]

		# Recolhe os nodos que serao comparados na sa2w
		tratbaselines <- intersect(which((TheTree$Level == (column + 1) )),which(TheTree$Father == node.number))
		tratbase <- TheTree[tratbaselines,]
# 		print(tratbase)
		
		# Cria a janela
		sa2wWindow <- tktoplevel()
		title <- "ArvoRe - Sensitivity Analysis"
		tkwm.title(sa2wWindow,title)
		
		frameOverall <- tkframe(sa2wWindow)
			frameUpper <- tkframe(frameOverall, relief="groove", borderwidth=0)
				frameUpperLeft <- tkframe(frameUpper, relief="groove", borderwidth=0)
					frameUpperLeftUp <- tkframe(frameUpperLeft, relief="groove", borderwidth=0)
					frameUpperLeftDown <- tkframe(frameUpperLeft, relief="groove", borderwidth=0)
				frameUpperRigth <- tkframe(frameUpper, relief="groove", borderwidth=2)
					frameUpperRigthUp <- tkframe(frameUpperRigth, relief="groove", borderwidth=0)
					frameUpperRigthDown <- tkframe(frameUpperRigth, relief="groove", borderwidth=0)
			frameLower <- tkframe(frameOverall, relief="groove", borderwidth=2)
	
		# Lista de variaveis 1
		scrvar <- tkscrollbar(frameUpperRigthUp, repeatinterval=5,
						command=function(...)tkyview(tlvar,...))
		tlvar <- tklistbox(frameUpperRigthUp,height=4,selectmode="single",
						yscrollcommand=function(...)tkset(scrvar,...),background="white")
		tkgrid(tklabel(frameUpperRigthUp,text="Variables 1"), column=0, row=0)
		tkgrid(tlvar, column=0, row=1)
		tkgrid(scrvar, column=1, row=1)
		tkgrid.configure(scrvar,rowspan=4,sticky="nsw")
	
		# Lista de variaveis 2
		scrvar2 <- tkscrollbar(frameUpperRigthUp, repeatinterval=5,
						command=function(...)tkyview(tlvar2,...))
		tlvar2 <- tklistbox(frameUpperRigthUp,height=4,selectmode="single",
						yscrollcommand=function(...)tkset(scrvar2,...),background="white")
		tkgrid(tklabel(frameUpperRigthUp,text="Variables 2"), column=2, row=0)
		tkgrid(tlvar2, column=2, row=1)
		tkgrid(scrvar2, column=3, row=1)
		tkgrid.configure(scrvar2,rowspan=4,sticky="nsw")
	
		tkgrid(frameUpperRigthUp, stick="nwe")
		tkgrid(frameUpperRigthDown, stick="nwe")
		tkgrid(frameUpperLeftUp, stick="nwe")
		tkgrid(frameUpperLeftDown, stick="nwe")
		tkgrid(frameUpperLeft, frameUpperRigth,sticky="nsw")
		tkgrid(frameUpper,sticky="ns", column=0, row=0, columnspan=2)
		tkgrid(frameLower,sticky="we", column=0, row=1, columnspan=2)
		
		variablesnames <- variableMAT[,1]
		
		if (length(variablesnames) > 0) {
			for (i in (1:length(variablesnames))) {
		    	tkinsert(tlvar,"end",variablesnames[i])
			}
		}
	
		if (length(variablesnames) > 0) {
			for (i in (1:length(variablesnames))) {
		    	tkinsert(tlvar2,"end",variablesnames[i])
			}
		}
	
		    Namevar <- tclVar("")
		    Minvar <- tclVar(0)
		    Maxvar <- tclVar(0)
			Intervals <- tclVar(10)
			
		    campowidth <- 25
			
			Intervals.var.Value  <- tkentry(frameUpperLeftUp, width=campowidth,textvariable=Intervals)
			tkgrid(tklabel(frameUpperLeftUp,text=" "), sticky = "n", column=0, row=3)
			tkgrid(tklabel(frameUpperLeftUp,text="Number of Intervals"), sticky = "n", column=0, row=4)
			tkgrid(Intervals.var.Value, sticky = "n", column=0, row=5)
	
			Name.var.Value  <- tkentry(frameUpperRigthDown, state="readonly", width=campowidth, textvariable=Namevar)
			tkgrid(tklabel(frameUpperRigthDown,text="Variable Name", padx = 15), sticky = "n", column=0, row=0)
			tkgrid(Name.var.Value, sticky = "n", column=0, row=1)
			
			Min.var.Value  <- tkentry(frameUpperRigthDown, width=campowidth,textvariable=Minvar)
			tkgrid(tklabel(frameUpperRigthDown,text="Minimum variable value"), padx = 15, sticky = "n", column=0, row=2)
			tkgrid(Min.var.Value, sticky = "n", column=0, row=3)
	
			Max.var.Value  <- tkentry(frameUpperRigthDown, width=campowidth,textvariable=Maxvar)
			tkgrid(tklabel(frameUpperRigthDown,text="Maximum variable value"), padx = 15, sticky = "n", column=0, row=4)
			tkgrid(Max.var.Value, sticky = "n", column=0, row=5)

		    Namevar2 <- tclVar("")
		    Minvar2 <- tclVar(0)
		    Maxvar2 <- tclVar(0)
			
		    campowidth <- 25
				
			Name.var.Value2  <- tkentry(frameUpperRigthDown, state="readonly", width=campowidth, textvariable=Namevar2)
			tkgrid(tklabel(frameUpperRigthDown,text="Variable 2 Name", padx = 15), sticky = "n", column=1, row=0)
			tkgrid(Name.var.Value2, sticky = "n", column=1, row=1)
			
			Min.var.Value2  <- tkentry(frameUpperRigthDown, width=campowidth,textvariable=Minvar2)
			tkgrid(tklabel(frameUpperRigthDown,text="Minimum variable 2 value"), padx = 15, sticky = "n", column=1, row=2)
			tkgrid(Min.var.Value2, sticky = "n", column=1, row=3)
	
			Max.var.Value2  <- tkentry(frameUpperRigthDown, width=campowidth,textvariable=Maxvar2)
			tkgrid(tklabel(frameUpperRigthDown,text="Maximum variable 2 value"), padx = 15, sticky = "n", column=1, row=4)
			tkgrid(Max.var.Value2, sticky = "n", column=1, row=5)
	
				
		DoSelection <- function(...)
		{
		    variableIndex <- as.integer(tkcurselection(tlvar))
	
		   	variableslist <- variableMAT$Name
		   	variableselected <- as.character(variableslist[variableIndex+1])
			
		   	assign("variableIndex", variableIndex, envir = parent.frame() )
		   	assign("variableselected", variableselected, envir = parent.frame() )
		   	
		    nintervals <- as.integer(tclvalue(Intervals))
		    
			tcl("set",Intervals,as.character(nintervals))
			tcl("set",Minvar,as.character(variableMAT$Min.Value[variableIndex+1]))
			tcl("set",Maxvar,as.character(variableMAT$Max.Value[variableIndex+1]))
			tcl("set",Namevar,as.character(variableMAT$Name[variableIndex+1]))
			
		}

		DoSelection2 <- function(...)
		{
		    variableIndex2 <- as.integer(tkcurselection(tlvar2))
	
		   	variableslist <- variableMAT$Name
		   	variableselected2 <- as.character(variableslist[variableIndex2+1])
	
		   	assign("variableIndex2", variableIndex2, envir = parent.frame() )
		   	assign("variableselected2", variableselected2, envir = parent.frame() )
		   	
		    nintervals <- as.integer(tclvalue(Intervals))
		    
			tcl("set",Intervals,as.character(nintervals))
			tcl("set",Minvar2,as.character(variableMAT$Min.Value[variableIndex2+1]))
			tcl("set",Maxvar2,as.character(variableMAT$Max.Value[variableIndex2+1]))
			tcl("set",Namevar2,as.character(variableMAT$Name[variableIndex2+1]))
			
		}
				
		OnVarInformation <- function()
		{
			show.summary.variables.window()
		}
		
		OnOK <- function()
		{
			doit <- TRUE
			# Bloco para a primeira variavel
# 		    variableIndex <- as.integer(tkcurselection(tlvar))
		   	variableslist <- variableMAT$Name
# 		   	variableselected <- as.character(variableslist[variableIndex+1])
		   	
# 		   	print(variableIndex)
# 		   	print(variableselected)
		   	
		   	if (length(variableIndex) < 1) {
			   	variableIndex <- -1
			   	variableselected <- ""
		   	}
		   	
		    nintervals <- as.integer(tclvalue(Intervals))
			maxval <- as.numeric(tclvalue(Maxvar))
			minval <- as.numeric(tclvalue(Minvar))
			
			# Bloco para a segunda variavel
# 		    variableIndex2 <- as.integer(tkcurselection(tlvar2))
# 		   	variableselected2 <- as.character(variableslist[variableIndex2+1])
		   	
# 		   	print(variableIndex2)
# 		   	print(variableselected2)
		   	
		   	if (length(variableIndex2) < 1) {
			   	variableIndex2 <- -1
			   	variableselected2 <- ""
		   	}
		   	
			maxval2 <- as.numeric(tclvalue(Maxvar2))
			minval2 <- as.numeric(tclvalue(Minvar2))

			
			if (((nchar(variableselected) < 1) || (nchar(variableselected2) < 1)) && doit ) {
				doit <- FALSE
				msg <- "Please, select two variables to perform the sensitivity analysis."
				tkmessageBox(message = msg, icon="error")
				tkfocus(sa2wWindow)
			}
			
			if (!is.integer(nintervals) && doit ) {
				doit <- FALSE
				msg <- "Invalid intervals value."
				tkmessageBox(message = msg, icon="error")
				tkfocus(sa2wWindow)
			}
			
			if ((!is.numeric(maxval) || !is.numeric(maxval2)) && doit ) {
				doit <- FALSE
				msg <- "Invalid maximum value."
				tkmessageBox(message = msg, icon="error")
				tkfocus(sa2wWindow)
			}
			
			if ((!is.numeric(minval) || !is.numeric(minval2)) && doit ) {
				doit <- FALSE
				msg <- "Invalid minimum value."
				tkmessageBox(message = msg, icon="error")
				tkfocus(sa2wWindow)
			}
			
			if ( (( minval >= maxval) || ( minval2 >= maxval2)) && doit ) {
				doit <- FALSE
				msg <- "The minimum value must be greater than maximum value."
				tkmessageBox(message = msg, icon="error")
				tkfocus(sa2wWindow)
			}
				   	
			if (( nintervals < 2) && doit ) {
				doit <- FALSE
				msg <- "Invalid intervals value. Set a value greater than 2, please."
				tkmessageBox(message = msg, icon="error")
				tkfocus(sa2wWindow)
			}
				   	
			# Se tudo esta ok, entao computa os resultados
			if ( doit ) {
				saw2anstable <- saw2.compute(variableselected, variableselected2, nintervals, minval, maxval, minval2, maxval2)
				
				saw2labelsselected <- array(,0)
				for (j in as.character(tratbase$Level)) {
					saw2labelsselectedtrans <- which(as.character(saw2anstable$Level) == j)
					saw2labelsselected <- c(saw2labelsselected, saw2labelsselectedtrans)
				}
				saw2labelsselected <- sort(union(integer(0),saw2labelsselected))
				saw2anstable <- saw2anstable[saw2labelsselected,]
				
				# Seleciona apenas o que interessa para exibicao
				saw2anstable <- data.frame(saw2anstable[,c(1,2,5,6,7,8)])

				assign("TabelaSA2w", saw2anstable, envir = .GlobalEnv)
				displayInTable.sa2w(saw2anstable, title="Sensitivity Analysis - Report",
								height=10,width=8, titlerows = FALSE, titlecols = TRUE)
				tkdestroy(sa2wWindow)
			}
		}
		
		OnCancel <- function()
		{
			tkdestroy(sa2wWindow)
			tkfocus(tt)
		}
		
		
			
			
		.Width.but <- 10
		.Height.but <- 1
		
		OK.but <-tkbutton(frameOverall,text="OK", width=.Width.but, height=.Height.but, command=OnOK)
		Cancel.but  <-tkbutton(frameOverall,text="Cancel", width=.Width.but, height=.Height.but, command=OnCancel)
		Select.but <-tkbutton(frameUpperLeftUp,text="Select 1", width=.Width.but, height=.Height.but,command=DoSelection)
		Select2.but <-tkbutton(frameUpperLeftUp,text="Select 2", width=.Width.but, height=.Height.but,command=DoSelection2)
		Information.but <-tkbutton(frameUpperLeftUp,text="Information", width=.Width.but, height=.Height.but,command=OnVarInformation)
	
		tkbind(sa2wWindow, "<Return>",OnOK)
		tkbind(sa2wWindow, "<Escape>",OnCancel)
		tkbind(tlvar,"<Double-Button-1>",DoSelection)
		tkbind(tlvar2,"<Double-Button-1>",DoSelection2)		
		
		tkgrid(OK.but, padx = 5, pady = 5, column=0, row=2, columnspan=1)
		tkgrid(Cancel.but, padx = 5, pady = 5, column=1, row=2, columnspan=1)
		tkgrid(Select.but, sticky = "s", padx = 5, pady = 5, column=0, row=0)
		tkgrid(Select2.but, sticky = "s", padx = 5, pady = 5, column=0, row=1)
		tkgrid(Information.but, sticky = "s", padx = 5, pady = 5, column=0, row=2)
		
		tkgrid(frameOverall, padx = 5, pady = 5)
		
	 	posiciona.janela.no.mouse(sa2wWindow, 510, 270)
						
		tkfocus(sa2wWindow)
	}	
}
