dialog.sensitivityanalysis.wn.window <-
function(...) {
	nodeSec <- nodoselecionado()
	if ( nodeSec[1] == " ") {
		msg <- paste("None node selected. Select a tree node and try again.")
		tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
		.begin.sim <- FALSE
		tkfocus(tt)
	} else {
		node.number <- as.numeric(nodeSec[3])
		column <- as.numeric(nodeSec[2])
		position <- intersect(which((TheTree$Level == column)),which(TheTree$Node.N == node.number))
		node.type <- TheTree$Type[position]

		# Recolhe os nodos que serao comparados na sa1w
		tratbaselines <- intersect(which((TheTree$Level == (column + 1) )),which(TheTree$Father == node.number))
		tratbase <- TheTree[tratbaselines,]
		
		# Cria a janela
		saNwWindow <- tktoplevel()
		title <- "ArvoRe - Sensitivity Analysis"
		tkwm.title(saNwWindow,title)
		
		frameOverall <- tkframe(saNwWindow)
			frameUpper <- tkframe(frameOverall, relief="groove", borderwidth=0)
				frameUpperLeft <- tkframe(frameUpper, relief="groove", borderwidth=0)
					frameUpperLeftUp <- tkframe(frameUpperLeft, relief="groove", borderwidth=0)
					frameUpperLeftDown <- tkframe(frameUpperLeft, relief="groove", borderwidth=0)
				frameUpperRigth <- tkframe(frameUpper, relief="groove", borderwidth=2)
					frameUpperRigthUp <- tkframe(frameUpperRigth, relief="groove", borderwidth=0)
					frameUpperRigthDown <- tkframe(frameUpperRigth, relief="groove", borderwidth=0)
			frameLower <- tkframe(frameOverall, relief="groove", borderwidth=2)
	
		scrvar <- tkscrollbar(frameUpperRigthUp, repeatinterval=5,
						command=function(...)tkyview(tlvar,...))
		tlvar <- tklistbox(frameUpperRigthUp,height=4,selectmode="multiple",
						yscrollcommand=function(...)tkset(scrvar,...),background="white")
		tkgrid(tklabel(frameUpperRigthUp,text="Variables"), column=0, row=0)
		tkgrid(tlvar, column=0, row=1)
		tkgrid(scrvar, column=1, row=1)
		tkgrid.configure(scrvar,rowspan=4,sticky="nsw")
		
		tkgrid(frameUpperRigthUp, stick="nwe")
		tkgrid(frameUpperRigthDown, stick="nwe")
		tkgrid(frameUpperLeftUp, stick="nwe")
		tkgrid(frameUpperLeftDown, stick="nwe")
		tkgrid(frameUpperLeft, frameUpperRigth,sticky="nsw")
		tkgrid(frameUpper,sticky="ns", column=0, row=0, columnspan=2)
		tkgrid(frameLower,sticky="we", column=0, row=1, columnspan=2)
		
		variablesnames <- variableMAT[,1]
		
		if (length(variablesnames) > 0) {
			for (i in (1:length(variablesnames))) {
		    	tkinsert(tlvar,"end",variablesnames[i])
			}
		}
		
		    # Namevar <- tclVar("")
		    # Minvar <- tclVar(0)
		    # Maxvar <- tclVar(0)
			Intervals <- tclVar(10)
			
		    campowidth <- 25
			
			Intervals.var.Value  <- tkentry(frameUpperLeftUp, width=campowidth,textvariable=Intervals)
			tkgrid(tklabel(frameUpperLeftUp,text=" "), sticky = "n", column=0, row=3)
			tkgrid(tklabel(frameUpperLeftUp,text="Number of Intervals"), sticky = "n", column=0, row=4)
			tkgrid(Intervals.var.Value, sticky = "n", column=0, row=5)
	
			# Name.var.Value  <- tkentry(frameUpperRigthDown, state="readonly", width=campowidth, textvariable=Namevar)
			# tkgrid(tklabel(frameUpperRigthDown,text="Variable Name", padx = 15), sticky = "n")
			# tkgrid(Name.var.Value, sticky = "n")
			
			# Min.var.Value  <- tkentry(frameUpperRigthDown, width=campowidth,textvariable=Minvar)
			# tkgrid(tklabel(frameUpperRigthDown,text="Minimum variable value"), padx = 15, sticky = "n")
			# tkgrid(Min.var.Value, sticky = "n")
	
			# Max.var.Value  <- tkentry(frameUpperRigthDown, width=campowidth,textvariable=Maxvar)
			# tkgrid(tklabel(frameUpperRigthDown,text="Maximum variable value"), padx = 15, sticky = "n")
			# tkgrid(Max.var.Value, sticky = "n")
	
		DoSelection <- function(...)
		{
		    variableIndex <- as.integer(tkcurselection(tlvar))
	
		   	variableslist <- variableMAT$Name
		   	variableselected <- as.character(variableslist[variableIndex+1])
	
		   	assign("variableIndex", variableIndex, envir = parent.frame() )
		   	assign("variableselected", variableselected, envir = parent.frame() )

		    nintervals <- as.integer(tclvalue(Intervals))
		    
			tcl("set",Intervals,as.character(nintervals))
			tcl("set",Minvar,as.character(variableMAT$Min.Value[variableIndex+1]))
			tcl("set",Maxvar,as.character(variableMAT$Max.Value[variableIndex+1]))
			tcl("set",Namevar,as.character(variableMAT$Name[variableIndex+1]))
			
		}
		
		OnVarInformation <- function()
		{
			show.summary.variables.window()
		}
		
		OnOK <- function()
		{
			doit <- TRUE
			
		    variableIndex <- as.integer(tkcurselection(tlvar))
			
		   	variableslist <- variableMAT$Name
			variableslistminvalue <- variableMAT$Min.Value
			variableslistmaxvalue <- variableMAT$Max.Value
			
		   	variableselected <- as.character(variableslist[variableIndex+1])
		   	variableselectedminvalue <- as.numeric( as.character(variableslistminvalue[variableIndex+1]) )
			variableselectedmaxvalue <- as.numeric( as.character(variableslistmaxvalue[variableIndex+1]) )
			
		   	# print(variableIndex)
		   	# print(variableselected)
		   	# print(variableselectedminvalue)
		   	# print(variableselectedmaxvalue)
		   	
		   	if (length(variableIndex) < 1) {
			   	variableIndex <- -1
			   	variableselected <- ""
		   	}
		   	
		    nintervals <- as.integer(as.character(tclvalue(Intervals)))
			
			if ((nchar(variableselected) < 1) && doit ) {
				doit <- FALSE
				msg <- "Please, select a variable to perform the sensitivity analysis."
				tkmessageBox(message = msg, icon="error")
				tkfocus(saNwWindow)
			}
			
			if (!is.integer(nintervals) && doit ) {
				doit <- FALSE
				msg <- "Invalid intervals value."
				tkmessageBox(message = msg, icon="error")
				tkfocus(saNwWindow)
			}
				   	
			if (( nintervals < 2) && doit ) {
				doit <- FALSE
				msg <- "Invalid intervals value. Set a value greater than 2, please."
				tkmessageBox(message = msg, icon="error")
				tkfocus(saNwWindow)
			}
				   	
			# Se tudo esta ok, entao computa os resultados
			if ( doit ) {
				#saw1anstable <- saw1.compute(variableselected, nintervals, minval, maxval)
				sawNanstablefilename <- codegensawn.compute(TheTree, variableselected, variableselectedmaxvalue, variableselectedminvalue, nintervals = nintervals)
				source(sawNanstablefilename)
				sawNanstable <- sawn.compute(...)
				
				# print("Verso completa : \n")
				# print( sawNanstable )
				# print( as.character(sawNanstable$Level) )
				
				sawNlabelsselected <- array(,0)
				
				# Seleciona apenas o que interessa para exibicao
				for (j in as.character(tratbase$Level)) {
					sawNlabelsselectedtrans <- which(as.character(sawNanstable$Level) == j)
					sawNlabelsselected <- c(sawNlabelsselected, sawNlabelsselectedtrans)
				}
				sawNlabelsselected <- sort(union(integer(0),sawNlabelsselected))
				sawNanstable <- sawNanstable[sawNlabelsselected,]
				
				sawNnumvariables <- length(variableselected)
				sawNcolsselected <- c( c(1:sawNnumvariables), c(4,5,6,7) + sawNnumvariables - 1 )
				sawNanstable <- data.frame(sawNanstable[,sawNcolsselected])
				
				# print( head( sawNanstable ) )
				# print( sawNanstable )

				displayInTable.sa2w(sawNanstable, title="Sensitivity Analysis - Report",
								height=10,width=8, titlerows = FALSE, titlecols = TRUE)
				tkdestroy(saNwWindow)
			}
		}
		
		OnCancel <- function()
		{
			tkdestroy(saNwWindow)
			tkfocus(tt)
		}
			
		.Width.but <- 10
		.Height.but <- 1
		
		OK.but <-tkbutton(frameOverall,text="OK", width=.Width.but, height=.Height.but, command=OnOK)
		Cancel.but  <-tkbutton(frameOverall,text="Cancel", width=.Width.but, height=.Height.but, command=OnCancel)
		Select.but <-tkbutton(frameUpperLeftUp,text="Select", state = "disabled", width=.Width.but, height=.Height.but,command=DoSelection)
		Information.but <-tkbutton(frameUpperLeftUp,text="Information", width=.Width.but, height=.Height.but,command=OnVarInformation)
	
		tkbind(saNwWindow, "<Return>",OnOK)
		tkbind(saNwWindow, "<Escape>",OnCancel)
		tkbind(tlvar,"<Double-Button-1>",DoSelection)
		
		tkgrid(OK.but, padx = 5, pady = 5, column=0, row=2, columnspan=1)
		tkgrid(Cancel.but, padx = 5, pady = 5, column=1, row=2, columnspan=1)
		tkgrid(Select.but, sticky = "s", padx = 5, pady = 5, column=0, row=0)
		tkgrid(Information.but, sticky = "s", padx = 5, pady = 5, column=0, row=1)
		
		tkgrid(frameOverall, padx = 5, pady = 5)
		
	 	posiciona.janela.no.mouse(saNwWindow, 340, 270)
						
		tkfocus(saNwWindow)
	}	
}
