saw1.compute <-
function(variableselected, nintervals, minval, maxval) {
	
	sarseqrange <- ( maxval - minval ) / (nintervals - 1)
	saseqvalues <- seq(minval, maxval, sarseqrange)
	
	labelsvalue <- array(,0)
	
	for (i in saseqvalues) {
		# Atualiza o valor da variavel a ser processada na sa1w (sensitivity analysis 1 way)
		assign(variableselected, i)
		assign(variableselected, i, envir = .GlobalEnv)
		
		TheTree <- get("TheTree", envir = .EnvironmentArvoRe)
		
		# Computa os valores das probabilidades que sao string
		TheTree$Prob <- sapply(TheTree$Prob,FUN = exec.text)
		TheTree$Payoff1 <- as.numeric(sapply(TheTree$Payoff1,FUN = exec.text))
		TheTree$Payoff2 <- as.numeric(sapply(TheTree$Payoff2,FUN = exec.text))

		numrep <- dim(TheTree)[1]
		
		# Gera a coluna com os valores usados na sa1w para a variavel
		labelsvalue <- c(labelsvalue, rep(i,numrep))
		
		# computa as esperancas com base no valor testado
		srspt <- summary.rollback.table(TheTree)
		
		names(srspt) <- c("Level", "Node N", "Node Name", 
						"Expected Cost", "Expected Effectiveness", "Expected C-E Ratio", 
						"Father Node", "Probability",
						"Cost", "Effectiveness", "Type")
		
		if ( exists("ans") ) {
			ans <- abind(ans,srspt,along=1)
		} else {
			ans <- srspt	
		}
	}
	
	ans <- data.frame(Value.Var=labelsvalue, ans)
	names(ans) <- c(variableselected, "Level", "Node N", "Node Name", 
						"Expected Cost", "Expected Effectiveness", "Expected C-E Ratio", 
						"Father Node", "Probability",
						"Cost", "Effectiveness", "Type")
						
	# Tratamento para tipos
	ans[,5] <- as.double(as.character(ans[,5]))
	ans[,6] <- as.double(as.character(ans[,6]))
	ans[,7] <- as.double(as.character(ans[,7]))

	assign("TabelaSA1w", ans, envir = .GlobalEnv)
	
	return(ans)
}
