status.simulation.window <-
function(...) {
	# Restore tcl values for GUI
	arvsimtrialnumber <- get("arvsimtrialnumber", envir = .EnvironmentArvoRe)
	arvsimulationstopflag <- get("arvsimulationstopflag", envir = .EnvironmentArvoRe)
	arvProcName <- get("arvProcName", envir = .EnvironmentArvoRe)
	arvNTrials <- get("arvNTrials", envir = .EnvironmentArvoRe)
	
	statussimulationwindow <- tktoplevel()
	assign(".window.statussimulationwindow", statussimulationwindow, envir = .EnvironmentArvoRe)
	
	title <- "ArvoRe - Markov Simulation"
	tkwm.title(statussimulationwindow,title)
	statussimulationwindow.l0 <- tklabel(statussimulationwindow, text = "Simulation running...")
	statussimulationwindow.l1 <- tklabel(statussimulationwindow, text = paste("(", arvProcName, ")", sep=""))
	statussimulationwindow.l2 <- tklabel(statussimulationwindow, text = "Trial ")
	statussimulationwindow.l3 <- tklabel(statussimulationwindow, textvariable = arvsimtrialnumber)
	statussimulationwindow.l4 <- tklabel(statussimulationwindow, text = paste("/", arvNTrials, sep=""))
	# tkconfigure(STOP.but, state="normal")
						
	OnStop <- function(...)
	{
		tcl("set", arvsimulationstopflag, 1)
		tkdestroy(statussimulationwindow)
		dialogsimulationwindow <- get(".window.dialogsimulationwindow", envir = .EnvironmentArvoRe)
		tkdestroy(dialogsimulationwindow)
		tkfocus(tt)
	}

	STOP.but <-tkbutton(statussimulationwindow, text="   STOP   ", command = OnStop)
	# tkconfigure(STOP.but, state="disabled")
						
	tkgrid(statussimulationwindow.l0, sticky = "n", padx = 5, pady = 5)
	tkgrid(statussimulationwindow.l1, sticky = "nwe", padx = 1, pady = 1)
	tkgrid(statussimulationwindow.l2, statussimulationwindow.l3, statussimulationwindow.l4, sticky = "n", padx = 5, pady = 5)
	tkgrid(STOP.but, sticky = "swe", padx = 5, pady = 5)
	tkfocus(statussimulationwindow)
}
