terminal.markov.coort.table <-
function(TheTree, trials = 2) {

	# Gera os valores das distribuies
	if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
		distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
		if ( length(distributionMAT$Name) > 0 ) {
			
			ndistributionMAT <- dim(distributionMAT)[1]
			distributionMAT.Names <- as.character(distributionMAT[,1])
			distributionMAT.Distribution <- as.character(distributionMAT[,3])
			distributionMAT.Parameters <- as.character(distributionMAT[,4])
			
			for ( i in 1:ndistributionMAT ) {
				commandoprocessar <- paste("assign('.distribution.Values.",distributionMAT.Names[i],"', r", distributionMAT.Distribution[i], "(trials, ", distributionMAT.Parameters[i], ") )", sep = "")
				eval(parse(text=commandoprocessar))
				commandoprocessar <- paste(".distribution.Values.",distributionMAT.Names[i]," <- r", distributionMAT.Distribution[i], "(trials, ", distributionMAT.Parameters[i], ")", sep = "")
				eval(parse(text=commandoprocessar))		
			}
		}
	}
	
	parse.distribution.expression <-
	function(exprdistr.arvore) {
		if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
			distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
			if ( length(distributionMAT$Name) > 0 ) {
				nexprdistr.arvore <- length(exprdistr.arvore)
				ndistributionMAT <- dim(distributionMAT)[1]
				distributionMAT.Names <- as.character(distributionMAT[,1])
				distributionMAT.Distribution <- as.character(distributionMAT[,3])
				distributionMAT.Parameters <- as.character(distributionMAT[,4])
				
				for ( i in 1:ndistributionMAT ) {
					commandoprocessar <- paste(".distribution.Values.",distributionMAT.Names[i],"[", trialnumber,"]", sep = "")
					.distribution.valordtr <- eval(parse(text=commandoprocessar))
					if ( sum(str_detect(exprdistr.arvore, distributionMAT.Names[i])) > 0 ) { 
							distributionMAT.valornovo <- .distribution.valordtr
							commandoprocessar <- str_replace_all(exprdistr.arvore, distributionMAT.Names[i], distributionMAT.valornovo)
							# distributionMAT.ans[j] <- eval(parse(text=commandoprocessar)) # no vamos retornar o valor...
							exprdistr.arvore <- commandoprocessar
						}
				}
			}
		} 
		return(exprdistr.arvore)
	}

	ctilityMAT <- array(TheTree$Payoff1,trials)
	ceffectivenessMAT <- array(TheTree$Payoff2,trials)
	
	for (i in 1:length(ctilityMAT) ) {
		trialnumber <- i
		
		ctilityMAT[i] <- parse.variable.expression(ctilityMAT[i])
		ctilityMAT[i] <- parse.distribution.expression(ctilityMAT[i])

		ceffectivenessMAT[i] <- parse.variable.expression(ceffectivenessMAT[i])
		ceffectivenessMAT[i] <- parse.distribution.expression(ceffectivenessMAT[i])
		
	}
	# print(ctilityMAT)	
	# print(ceffectivenessMAT)

	
	# cria a tabela de resposta
	Coorte.Ind <- matrix("1",1,trials)		# Matriz com cada individuo
	# print(Coorte.Ind)
	
	nctilityMAT <- array(0,length(ctilityMAT))
	nceffectivenessMAT <- array(0,length(ceffectivenessMAT))
	
	for (i in 1:length(ctilityMAT) ) {
		nctilityMAT[i] <- exec.text(ctilityMAT[i])
		nceffectivenessMAT[i] <- exec.text(ceffectivenessMAT[i])
	}

	Coorte.Cost <- matrix(nctilityMAT,1,trials)	# Matriz com custo de cada individuo
	# print(Coorte.Cost)
	
	Coorte.Effec <- matrix(nceffectivenessMAT,1,trials)	# Matriz com a efetividade de cada individuo
	# print(Coorte.Effec)

	ans <- list(Path = Coorte.Ind, Cost = Coorte.Cost, Effectiveness = Coorte.Effec)
	return(ans)	# And return the result
	
}
