utilitywindows <-
function() {
	nodeSec <- nodoselecionado()
	if ( nodeSec[1] == " ") {
		msg <- paste("None selected node. Select a tree node and try again.")
		tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
		tkfocus(tt)
	} else {
		utilityWindow <- tktoplevel()
		title <- "ArvoRe - Node Payoffs"
		tkwm.title(utilityWindow,title)

		node.number <- as.numeric(nodeSec[3])
		column <- as.numeric(nodeSec[2])
		position <- intersect(which((TheTree$Level == column)),which(TheTree$Node.N == node.number))
		
		utilityvar <- tclVar(TheTree$Payoff1[position])
		effectivenessvar <- tclVar(TheTree$Payoff2[position])
		
		# Entry for Payoff1
		OnFEUtility1 <- function()
		{
			dialog.formulaeditor.window(TheTree, "Payoff1", utilityvar)
		}
		
		entry.Value  <- tkentry(utilityWindow,width="20",textvariable=utilityvar)
		label.entry.Value.utility <- tklabel(utilityWindow,text="Cost value")
		.Width.but <- 5 ; .Height.but <- 1
		utility.but <- tkbutton(utilityWindow,text="...", width=.Width.but, height=.Height.but, command = OnFEUtility1 )
		
		# Entry for Payoff2
		OnFEUtility2 <- function()
		{
			dialog.formulaeditor.window(TheTree, "Payoff2", effectivenessvar)
		}
		
		entry.Value.effectiveness  <- tkentry(utilityWindow,width="20",textvariable=effectivenessvar)
		label.entry.Value.effect <- tklabel(utilityWindow,text="Effectiveness value")
		effectiveness.but <- tkbutton(utilityWindow,text="...", width=.Width.but, height=.Height.but, command = OnFEUtility2 )

		tkgrid(label.entry.Value.utility)
		tkgrid(entry.Value, utility.but)
		tkgrid(label.entry.Value.effect)
		tkgrid(entry.Value.effectiveness, effectiveness.but)
		
		if (.modeltypeArvore == "SD") {
			tkconfigure(entry.Value.effectiveness, state = "disabled")
			tkconfigure(label.entry.Value.effect, state = "disabled")
		}
		
		OnOK <- function()
		{
# 			utilityVal <- as.numeric(tclvalue(utilityvar))
# 			effectivenessVal <- as.numeric(tclvalue(effectivenessvar))
			
			utilityVal <- as.character(tclvalue(utilityvar))
			effectivenessVal <- as.character(tclvalue(effectivenessvar))			
			
			if ( (is.character(utilityVal)) && (!is.na(utilityVal)) &&
				 (is.character(effectivenessVal)) && (!is.na(effectivenessVal)) ) {
				tkdestroy(utilityWindow)
				
				safedofunction(TheTree, .EnvironmentArvoRe, .modeltypeArvore)
				
				commandstringformat <- paste("setutility(TheTree, column = ", nodeSec[2],", node.number = ", nodeSec[3],", pvalue = '", utilityVal,"', .EnvironmentArvoRe)", sep="")
				add.Syntax(commandstringformat)
				setutility(TheTree, nodeSec[2], nodeSec[3], utilityVal, .EnvironmentArvoRe)
				
				commandstringformat <- paste("seteffectiveness(TheTree, column = ", nodeSec[2],", node.number = ", nodeSec[3],", pvalue = '", effectivenessVal,"', .EnvironmentArvoRe)", sep="")
				add.Syntax(commandstringformat)
				seteffectiveness(TheTree, nodeSec[2], nodeSec[3], effectivenessVal, .EnvironmentArvoRe)
				
				refreshF5()
				tkfocus(tt)
			} else {
				msg <- paste("Invalid utility value/expression '",utilityVal, "'")
				tkmessageBox(message=msg)
				tkfocus(utilityWindow)
			}
		}
		OK.but <-tkbutton(utilityWindow,text="    OK    ",command=OnOK)
		
		OnCancel <- function()
		{
			tkdestroy(utilityWindow)
			tkfocus(tt)
		}
		
		Cancel.but <-tkbutton(utilityWindow,text=" Cancel ",command=OnCancel)
		
		tkbind(entry.Value, "<Return>",OnOK)
		tkbind(entry.Value.effectiveness, "<Return>",OnOK)
		tkbind(utilityWindow, "<Escape>",OnCancel)

		tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)

		posiciona.janela.no.mouse(utilityWindow, 200, 130)
		tkfocus(utilityWindow)
	}
}
